'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ProxyConnectHOC = function ProxyConnectHOC(WrapperComponent) {

  var generateProxyIntoObject = function generateProxyIntoObject(proxyObject) {
    var $$cloneProxyIntoObjectStore = {};
    Reflect.ownKeys(proxyObject).forEach(function (key) {
      Object.assign($$cloneProxyIntoObjectStore, _defineProperty({}, key, proxyObject[key]));
    });
    return $$cloneProxyIntoObjectStore;
  };

  var ProxyConnect = function (_Component) {
    _inherits(ProxyConnect, _Component);

    function ProxyConnect(props, context) {
      _classCallCheck(this, ProxyConnect);

      var _this = _possibleConstructorReturn(this, (ProxyConnect.__proto__ || Object.getPrototypeOf(ProxyConnect)).call(this, props, context));

      _this.store = props.store || context.store;
      _this.store.subscribe = _react2.default.Component.prototype.forceUpdate.bind(_this);
      return _this;
    }

    _createClass(ProxyConnect, [{
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.store.unsubscribe = this.store.subscribe;
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(WrapperComponent, Object.assign({}, this.props, {
          store: generateProxyIntoObject(this.store)
        }));
      }
    }]);

    return ProxyConnect;
  }(_react.Component);

  ProxyConnect.contextTypes = {
    store: _react2.default.PropTypes.object
  };

  return (0, _hoistNonReactStatics2.default)(ProxyConnect, WrapperComponent);
};

exports.default = ProxyConnectHOC;